<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 11/15/2003 *
 * ===================                          Last change: 04/02/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-logs.php                                    *
 * -------------------------------------------------------------------- *
 * Short description : Management for access log files                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Management fuer Zugriffslogbuecher               *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('admin', __FILE__);

if (isGetRequestParameterSet('access')) {
	// Secure input and construct FQFN
	$access = SQL_ESCAPE(secureString(getRequestParameter('access')));
	$target = sprintf("%slogs/%s", getPath(), $access);

	// Is the file valid and readable?
	if (isFileReadable($target)) {
		// Load it directly
		$content = readFromFile($target);

		// Set header
		if (substr($access, -3, 3) == 'log') {
			// Output header
			sendHeader('Content-Type: text/plain');

			// Clean content
			clearOutputBuffer();
		} elseif (substr($access, -3, 3) == '.gz') {
			// @TODO Fix content-type here
			sendHeader('Content-Type: text/plain');

			// Clean content
			clearOutputBuffer();
		} elseif (substr($access, -3, 3) == '.bz2') {
			// @TODO Fix content-type here
			sendHeader('Content-Type: text/plain');

			// Clean content
			clearOutputBuffer();
		} else {
			// Output message
			loadTemplate('admin_settings_saved', false, getMaskedMessage('ADMIN_UNKNOWN_LOGFILE_FORMAT', $access));
			return;
		}

		// Output the logfile's content and exit
		print($content);
		shutdown();
	} else {
		// Not readable!
		loadTemplate('admin_settings_saved', false, getMaskedMessage('LOGFILE_NOT_READABLE', $access));
	}
} else {
	// Is the directory there?
	if (isDirectory(getPath() . getConfig('logs_base'))) {
		// Logs directory does exist so begin the list
		outputHtml('<ol>');

		// Read all files
		foreach (getArrayFromDirectory(getConfig('logs_base'), 'access') as $file) {
			// Cut dirname away
			$file = basename($file);

			// Okay, add it
			outputHtml('<li><a href="{%url=modules.php?module=admin&amp;what=' . getWhat() . '&amp;access=' . urlencode($file) . '%}">' . $file . '</a></li>');
		} // END - foreach

		// Finish list
		outputHtml('</ol>');
	} else {
		// logs directory does not exist
		loadTemplate('admin_settings_saved', false, '{--ADMIN_LOGS_DIR_404--}');
	}
}

// [EOF]
?>
